﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.WoWInternals.WoWObjects;

namespace GreenDot.Affli
{
    class AffliSettings : Settings
    {
        public static readonly AffliSettings Get = new AffliSettings();

        public AffliSettings() 
            :base(Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Routines/GreenDot/Settings/{0}-GreenDotSettings-{1}.xml", StyxWoW.Me.RealmName, StyxWoW.Me.Name)))
        {
        }

        // Demonic Circle
        [Setting, DefaultValue(true)]
        public bool Circle { get; set; }

        [Setting, DefaultValue(false)]
        public bool CircleOnCooldown { get; set; }

        [Setting, DefaultValue(true)]
        public bool CircleOnLowHealth { get; set; }

        [Setting, DefaultValue(50)]
        public int CircleHealth { get; set; }

        // Soulwell
        [Setting, DefaultValue(true)]
        public bool Soulwell { get; set; }

        [Setting, DefaultValue(false)]
        public bool SoulwellInCombat { get; set; }

        [Setting, DefaultValue(5)]
        public int SoulwellFriends { get; set; }

        // Soulburn
        [Setting, DefaultValue(false)]
        public bool SoulburnForSwap { get; set; }

        [Setting, DefaultValue(true)]
        public bool SoulburnForHaunt { get; set; }

        // Trinket 1
        [Setting, DefaultValue(false)]
        public bool Trinket1 { get; set; }

        [Setting, DefaultValue(false)]
        public bool Trinket1OnCooldown { get; set; }

        [Setting, DefaultValue(false)]
        public bool Trinket1LostOfControl { get; set; }

        // Trinket 2
        [Setting, DefaultValue(false)]
        public bool Trinket2 { get; set; }

        [Setting, DefaultValue(false)]
        public bool Trinket2OnCooldown { get; set; }

        [Setting, DefaultValue(false)]
        public bool Trinket2LostOfControl { get; set; }

        // Special Demon
        [Setting, DefaultValue(false)]
        public bool Infernal { get; set; }

        [Setting, DefaultValue(false)]
        public bool Doomguard { get; set; }

        // Fear Control
        [Setting, DefaultValue(false)]
        public bool FearOnLowHealth { get; set; }

        [Setting, DefaultValue(50)]
        public int FearHealth { get; set; }

        [Setting, DefaultValue(false)]
        public bool FearAOE { get; set; }

        [Setting, DefaultValue(1)]
        public int FearAOECounter { get; set; }

        [Setting, DefaultValue(false)]
        public bool FearOnCombatBegin { get; set; }

        // General
        [Setting, DefaultValue(true)]
        public bool DrainLife { get; set; }

        [Setting, DefaultValue(50)]
        public int DrainLifeHealth  { get; set; }

        [Setting, DefaultValue(true)]
        public bool DarkSoulMisery { get; set; }

        [Setting, DefaultValue(true)]
        public bool BloodHorror { get; set; }

        [Setting, DefaultValue(true)]
        public bool SacrificialPact { get; set; }

        [Setting, DefaultValue(50)]
        public int SacrificialPactHealth { get; set; }

        [Setting, DefaultValue(true)]
        public bool UnendingBreath { get; set; }

        [Setting, DefaultValue(true)]
        public bool Soulstone { get; set; }
}
}
