﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals.WoWObjects;

namespace GreenDot.Affli
{
    class Rotations
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private static WoWUnit CTarget { get { return Me.CurrentTarget; } }

        private static AffliSettings Set = new AffliSettings();

        private static DateTime dtFearTimer, dtFellhunter, dtHealthstone = new DateTime();

        public static async Task<bool> PreCombatBuffRoutine()
        {
            // Finstere Absichten
            await Tools.Cast(Spellbook.buff_FinstereAbsichten, !Me.HasAura(Spellbook.buff_FinstereAbsichten), Me);

            // Teufelsjäger beschwören
            if (await Tools.Cast(Spellbook.spell_SummonTäufelsjäger, !Me.HasAura(Spellbook.talent_GrimoireDerOpferung) && Me.Pet == null, Me)) dtFellhunter = DateTime.Now.AddSeconds(3);

            // Blutschrecken
            await Tools.Cast(Spellbook.talent_Blutschrecken, !Tools.HasAura(Me, Spellbook.talent_Blutschrecken) && !Me.Mounted && Set.BloodHorror, Me);

            // Unending Breath
            await Tools.Cast(Spellbook.buff_UnendingBreath, !Me.HasAura(Spellbook.buff_UnendingBreath) && Set.UnendingBreath, Me);

            // Grimoire der Opferung
            await Tools.Cast(Spellbook.talent_GrimoireDerOpferung, !Me.HasAura(Spellbook.talent_GrimoireDerOpferung) && Me.Pet != null, Me);

            // Seelenbrunnen
            await Tools.Cast(Spellbook.spell_Seelenbrunnen, await Tools.GetFriendsInRange(25) >= Set.SoulwellFriends && Set.Soulwell && !Me.Combat, Me);

            // Soulstone
            await Tools.Cast(Spellbook.spell_Seelenstein, Set.Soulstone && !Me.HasAura(Spellbook.spell_Seelenstein) && !Me.Combat, Me);

            // Gesundheitssteine erstellen
            if (await Tools.Cast(Spellbook.spell_Gesundheitssteinherstellen, !Tools.HasItem(Spellbook.item_Gesundheitsstein), Me)) dtHealthstone = DateTime.Now.AddSeconds(3);

            return false;
        }

        public static async Task<bool> PullRoutine()
        {
            if (CTarget == null)
            {
                var Attackers = await Tools.GetAttackers();
                var Enemys = await Tools.GetEnemys();
                var Healers = await Tools.GetEnemyHealers();

                if (Healers.Any())
                {
                    Healers.OrderBy(u => u.HealthPercent).ToList();

                    var Healer = Healers.FirstOrDefault();

                    if(Healer != null) Healer.Target();
                }
                else if (Attackers.Any())
                {
                    Attackers.OrderBy(u => u.Distance).ToList();

                    var Enemy = Attackers.FirstOrDefault();

                    if(Enemy != null) Enemy.Target();
                }
                else if (Enemys.Any())
                {
                    Enemys.OrderBy(u => u.Distance).ToList();

                    var Enemy = Enemys.FirstOrDefault();

                    if(Enemy != null) Enemy.Target();
                }
            }

            // Circle
            await Tools.Cast(Spellbook.spell_DemonischerZirkel_Beschwören, !Me.HasAura(Spellbook.spell_DemonischerZirkel_Beschwören) && Set.Circle, Me);

            // Circle on Cooldown
            await Tools.Cast(Spellbook.spell_DemonischerZirkel_Teleport, Me.HasAura(Spellbook.spell_DemonischerZirkel_Beschwören) && Set.Circle && Set.CircleOnCooldown, Me);

            // Fear on Combat begin
            await Tools.Cast(Spellbook.spell_Angst, Tools.HasAura(CTarget, Spellbook.spell_Angst) && Set.FearOnCombatBegin, CTarget);
            
            return true;
        }

        public static async Task<bool> CombatRoutine()
        {
            // Trinket 1
            await Tools.UseTrinket(1, Set.Trinket1 && Set.Trinket1OnCooldown);
            await Tools.UseTrinket(1, Set.Trinket1 && Set.Trinket1LostOfControl && Tools.LostOfControl(Me));

            // Trinket 2
            await Tools.UseTrinket(2, Set.Trinket2 && Set.Trinket2OnCooldown);
            await Tools.UseTrinket(2, Set.Trinket2 && Set.Trinket2LostOfControl && Tools.LostOfControl(Me));

            // Sacrificial Pact
            await Tools.Cast(Spellbook.talent_Opferpakt, Set.SacrificialPact && Me.HealthPercent <= Set.SacrificialPactHealth, Me);

            // Use Healthstone
            await Tools.UseItem(Spellbook.item_Gesundheitsstein, Me.HealthPercent <= Set.DrainLifeHealth);

            // Aoe Fear
            await Tools.Cast(Spellbook.talent_Schreckensgeheul, Set.FearAOE && await Tools.GetEnemysInRange(10) >= Set.FearAOECounter, Me);

            // Spell Lock
            await Tools.Cast(Spellbook.spell_Zaubersperre, Tools.CanSpellLock(CTarget), CTarget);

            // Fear enemy on low health
            await Tools.Cast(Spellbook.spell_Angst, Set.FearOnLowHealth && CTarget.HealthPercent <= Set.FearHealth && !Tools.HasAura(CTarget, Spellbook.spell_Angst) && Tools.Dotted(CTarget), CTarget);
            
            // Dark Soul: Misery
            await Tools.Cast(Spellbook.buff_FinstereSeeleElend, Set.DarkSoulMisery && !Me.HasAura(Spellbook.buff_FinstereSeeleElend), Me);

            // Infernal
            await Tools.CastGroundSpell(Spellbook.spell_SummonInfernal, Set.Infernal && await Tools.GetEnemysInRangeFromTarget(30, CTarget, 3), CTarget);

            // Doomguard
            await Tools.Cast(Spellbook.spell_SummonDoomGuard, Set.Doomguard && Me.HealthPercent >= 80 && CTarget.HealthPercent <= 50, CTarget);

            // Soulwell
            await Tools.Cast(Spellbook.spell_Seelenbrunnen, Set.Soulwell && Set.SoulwellInCombat && await Tools.GetFriendsInRange(20) >= Set.SoulwellFriends && Me.Combat, Me);

            // Summon Circle
            await Tools.Cast(Spellbook.spell_DemonischerZirkel_Beschwören, !Me.HasAura(Spellbook.spell_DemonischerZirkel_Beschwören), Me);

            // Circle on low Health
            await Tools.Cast(Spellbook.spell_DemonischerZirkel_Teleport, Set.Circle && Set.CircleOnLowHealth && Me.HealthPercent <= Set.CircleHealth, Me);

            // Blutschrecken
            await Tools.Cast(Spellbook.talent_Blutschrecken, !Tools.HasAura(Me, Spellbook.talent_Blutschrecken) && !Me.Mounted && Set.BloodHorror, Me);

            // Cataclysm (if skilled)
            await Tools.CastGroundSpell(Spellbook.talent_Cataclysm, await Tools.GetEnemysInRangeFromTarget(8, CTarget, 2) && Set.SoulburnForSwap, CTarget);

            // Dark Bargain (if skilled)
            await Tools.Cast(Spellbook.talent_DarkBargain, Me.HealthPercent <= Set.SacrificialPactHealth && Me.Combat, Me);

            // Fear
            if (await Tools.Cast(Spellbook.spell_Angst, dtFearTimer < DateTime.Now && !Set.FearOnLowHealth && !Tools.HasAura(CTarget ,Spellbook.spell_Angst), CTarget)) dtFearTimer = DateTime.Now.AddSeconds(5);

            #region Check Routine for Soulburn Haunt
            if (Set.SoulburnForHaunt && CTarget != null)
            {
                // Verderbnis
                await Tools.Cast(Spellbook.spell_Verderbnis, !Tools.HasAura(CTarget, Spellbook.aura_Verderbnis), CTarget);

                // Agonie
                await Tools.Cast(Spellbook.spell_Agonie, !Tools.HasAura(CTarget, Spellbook.spell_Agonie), CTarget);

                // Instabiles Gebrechen
                await Tools.Cast(Spellbook.spell_InstabilesGebrechen, !Tools.HasAura(CTarget, Spellbook.spell_InstabilesGebrechen), CTarget);

                // Soulburn
                await Tools.Cast(Spellbook.spell_Seelenbrand, !Tools.HasAura(CTarget, Spellbook.aura_Heimsuchung) && !Me.HasAura(Spellbook.spell_Seelenbrand) && Me.CurrentSoulShards >= 2 && Tools.Dotted(CTarget), Me);

                await CommonCoroutines.SleepForLagDuration();

                // Haunt
                await Tools.Cast(Spellbook.spell_Heimsuchung, !Tools.HasAura(CTarget, Spellbook.aura_Heimsuchung) && Me.HasAura(Spellbook.spell_Seelenbrand) && Tools.Dotted(CTarget), CTarget);
            }
            #endregion

            #region Check Routine for Soulburn Swap
            if (Set.SoulburnForSwap && CTarget != null)
            {
                if (Me.CurrentSoulShards < 2)
                {
                    // Verderbnis
                    await Tools.Cast(Spellbook.spell_Verderbnis, !Tools.HasAura(CTarget, Spellbook.aura_Verderbnis), CTarget);

                    // Agonie
                    await Tools.Cast(Spellbook.spell_Agonie, !Tools.HasAura(CTarget, Spellbook.spell_Agonie), CTarget);

                    // Instabiles Gebrechen
                    await Tools.Cast(Spellbook.spell_InstabilesGebrechen, !Tools.HasAura(CTarget, Spellbook.spell_InstabilesGebrechen), CTarget);
                }
                else
                {
                    // Soulburn
                    await Tools.Cast(Spellbook.spell_Seelenbrand, !Tools.HasAura(CTarget, Spellbook.spell_Seelenbrand) && Me.CurrentSoulShards >= 2 && !Tools.Dotted(CTarget), Me);

                    // Swap
                    await Tools.Cast(Spellbook.spell_SoulSwapGet, Me.HasAura(Spellbook.spell_Seelenbrand) && Me.CurrentSoulShards >= 1 && !Tools.Dotted(CTarget), CTarget);
                }

                // Haunt
                await Tools.Cast(Spellbook.spell_Heimsuchung, !Tools.HasAura(CTarget, Spellbook.aura_Heimsuchung) && Tools.Dotted(CTarget), CTarget);
            }
            #endregion

            #region Check Routine for Routine without Soulburn
            if (!Set.SoulburnForHaunt && !Set.SoulburnForSwap)
            {
                // Verderbnis
                await Tools.Cast(Spellbook.spell_Verderbnis, !Tools.HasAura(CTarget, Spellbook.aura_Verderbnis), CTarget);

                // Agonie
                await Tools.Cast(Spellbook.spell_Agonie, !Tools.HasAura(CTarget, Spellbook.aura_Verderbnis) && !CTarget.HasAura(Spellbook.spell_Agonie), CTarget);

                // Instabiles Gebrechen
                await Tools.Cast(Spellbook.spell_InstabilesGebrechen, !Tools.HasAura(CTarget, Spellbook.aura_Verderbnis) && !CTarget.HasAura(Spellbook.spell_Agonie) &&
                        !CTarget.HasAura(Spellbook.spell_InstabilesGebrechen), CTarget);

                // Haunt
                await Tools.Cast(Spellbook.spell_Heimsuchung, !Tools.HasAura(CTarget, Spellbook.aura_Heimsuchung) && Tools.Dotted(CTarget), CTarget);
            }
            #endregion

            // Drain Life
            await Tools.Cast(Spellbook.spell_Blutsauger, Me.HealthPercent <= Set.DrainLifeHealth && Set.DrainLife, CTarget);

            // Seelendieb
            await Tools.Cast(Spellbook.spell_Seelendieb, Tools.Dotted(CTarget) && Tools.IsValid(CTarget), CTarget);

            return true;
        }
    }
}
