﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GreenDot.Affli
{
    public partial class frmForm : Form
    {
        private Affli.AffliSettings Settings = new AffliSettings();

        public frmForm()
        {
            InitializeComponent();

            // Demonic Circle
            cBoxCircle.Checked = Settings.Circle;
            cBoxCircleOnCoolDown.Checked = Settings.CircleOnCooldown;
            cBoxCircleOnLowHealth.Checked = Settings.CircleOnLowHealth;
            nUPCircleHealth.Value = new decimal(Settings.CircleHealth);

            // Soulwell
            cBoxSoulwell.Checked = Settings.Soulwell;
            cBoxSoulwellOnCombat.Checked = Settings.SoulwellInCombat;
            nUPSoulwellFriends.Value = new decimal(Settings.SoulwellFriends);

            // Soulburn
            cBoxSoulburnForSwap.Checked = Settings.SoulburnForSwap;
            cBoxSoulburnForHaunt.Checked = Settings.SoulburnForHaunt;

            // Trinket 1
            cBoxTrinket1.Checked = Settings.Trinket1;
            cBoxTrinket1OnCoolDown.Checked = Settings.Trinket1OnCooldown;
            cBoxTrinket1OnLostOfControl.Checked = Settings.Trinket1LostOfControl;

            // Trinket 2
            cBoxTrinket2.Checked = Settings.Trinket2;
            cBoxTrinket2OnCoolDown.Checked = Settings.Trinket2OnCooldown;
            cBoxTrinket2OnLostOfControl.Checked = Settings.Trinket2LostOfControl;

            // Special Demon
            cBoxInfernal.Checked = Settings.Infernal;
            cBoxDoomguard.Checked = Settings.Doomguard;

            // Fear Control
            cBoxFearOnLowHealth.Checked = Settings.FearOnLowHealth;
            nUPFearHealth.Value = new decimal(Settings.FearHealth);
            cBoxFearAOE.Checked = Settings.FearAOE;
            nUPFearCounter.Value = new decimal(Settings.FearAOECounter);
            cBoxFearOnCombatBegin.Checked = Settings.FearOnCombatBegin;

            // General
            cBoxDrainLife.Checked = Settings.DrainLife;
            nUPDrainLifeHealth.Value = new decimal(Settings.DrainLifeHealth);
            cBoxDarkSoulMisery.Checked = Settings.DarkSoulMisery;
            cBoxBloodHorror.Checked = Settings.BloodHorror;
            cBoxSacrificialPact.Checked = Settings.SacrificialPact;
            nUPSacrificialPactHealth.Value = new decimal(Settings.SacrificialPactHealth);
            cBoxUnendingBreath.Checked = Settings.UnendingBreath;
            cBoxSoulstone.Checked = Settings.Soulstone;
        }

        // Demonic Circle
        private void cBoxCircle_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Circle = cBoxCircle.Checked;
        }

        private void cBoxCircleOnCoolDown_CheckedChanged(object sender, EventArgs e)
        {
            Settings.CircleOnCooldown = cBoxCircleOnCoolDown.Checked;
        }

        private void cBoxCircleOnLowHealth_CheckedChanged(object sender, EventArgs e)
        {
            Settings.CircleOnLowHealth = cBoxCircleOnLowHealth.Checked;
        }

        private void nUPCircleHealth_ValueChanged(object sender, EventArgs e)
        {
            Settings.CircleHealth = (int)nUPCircleHealth.Value;
        }

        // Soulwell
        private void cBoxSoulwell_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Soulwell = cBoxSoulwell.Checked;
        }

        private void cBoxSoulwellOnCombat_CheckedChanged(object sender, EventArgs e)
        {
            Settings.SoulwellInCombat = cBoxSoulwellOnCombat.Checked;
        }

        private void nUPSoulwellFriends_ValueChanged(object sender, EventArgs e)
        {
            Settings.SoulwellFriends = (int)nUPSoulwellFriends.Value;
        }

        // Soulburn
        private void cBoxSoulburnForSwap_CheckedChanged(object sender, EventArgs e)
        {
            Settings.SoulburnForSwap = cBoxSoulburnForSwap.Checked;

            if (cBoxSoulburnForSwap.Checked)
            {
                cBoxSoulburnForHaunt.Checked = false;
                Settings.SoulburnForHaunt = false;
            }
        }

        private void cBoxSoulburnForHaunt_CheckedChanged(object sender, EventArgs e)
        {
            Settings.SoulburnForHaunt = cBoxSoulburnForHaunt.Checked;

            if (cBoxSoulburnForHaunt.Checked)
            {
                cBoxSoulburnForSwap.Checked = false;
                Settings.SoulburnForSwap = false;
            }
        }

        // Trinket 1
        private void cBoxTrinket1_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket1 = cBoxTrinket1.Checked;
        }

        private void cBoxTrinket1OnCoolDown_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket1OnCooldown = cBoxTrinket1OnCoolDown.Checked;
        }

        private void cBoxTrinket1OnLostOfControl_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket1LostOfControl = cBoxTrinket1OnLostOfControl.Checked;
        }

        // Trinket 2
        private void cBoxTrinket2_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket2 = cBoxTrinket2.Checked;
        }

        private void cBoxTrinket2OnCoolDown_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket2OnCooldown = cBoxTrinket2OnCoolDown.Checked;
        }

        private void cBoxTrinket2OnLostOfControl_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Trinket2LostOfControl = cBoxTrinket2OnLostOfControl.Checked;
        }

        // Special Demon
        private void cBoxInfernal_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Infernal = cBoxInfernal.Checked;

            if (cBoxInfernal.Checked)
            {
                cBoxDoomguard.Checked = false;
                Settings.Doomguard = false;
            }
        }

        private void cBoxDoomguard_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Doomguard = cBoxDoomguard.Checked;

            if (cBoxDoomguard.Checked)
            {
                cBoxInfernal.Checked = false;
                Settings.Infernal = false;
            }
        }

        // Fear Control
        private void cBoxFearOnLowHealth_CheckedChanged(object sender, EventArgs e)
        {
            Settings.FearOnLowHealth = cBoxFearOnLowHealth.Checked;
        }

        private void nUPFearHealth_ValueChanged(object sender, EventArgs e)
        {
            Settings.FearHealth = (int)nUPFearHealth.Value;
        }

        private void cBoxFearAOE_CheckedChanged(object sender, EventArgs e)
        {
            Settings.FearAOE = cBoxFearAOE.Checked;
        }

        private void nUPFearCounter_ValueChanged(object sender, EventArgs e)
        {
            Settings.FearAOECounter = (int) nUPFearCounter.Value;
        }

        private void cBoxFearOnCombatBegin_CheckedChanged(object sender, EventArgs e)
        {
            Settings.FearOnCombatBegin = cBoxFearOnCombatBegin.Checked;
        }

        // General
        private void cBoxDrainLife_CheckedChanged(object sender, EventArgs e)
        {
            Settings.DrainLife = cBoxDrainLife.Checked;
        }

        private void nUPDrainLifeHealth_ValueChanged(object sender, EventArgs e)
        {
            Settings.DrainLifeHealth = (int) nUPDrainLifeHealth.Value;
        }

        private void cBoxDarkSoulMisery_CheckedChanged(object sender, EventArgs e)
        {
            Settings.DarkSoulMisery = cBoxDarkSoulMisery.Checked;
        }

        private void cBoxBloodHorror_CheckedChanged(object sender, EventArgs e)
        {
            Settings.BloodHorror = cBoxBloodHorror.Checked;
        }

        private void cBoxSacrificialPact_CheckedChanged(object sender, EventArgs e)
        {
            Settings.SacrificialPact = cBoxSacrificialPact.Checked;
        }

        private void nUPSacrificialPactHealth_ValueChanged(object sender, EventArgs e)
        {
            Settings.SacrificialPactHealth = (int) nUPSacrificialPactHealth.Value;
        }

        private void cBoxUnendingBreath_CheckedChanged(object sender, EventArgs e)
        {
            Settings.UnendingBreath = cBoxUnendingBreath.Checked;
        }

        private void cBoxSoulstone_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Soulstone = cBoxSoulstone.Checked;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Settings.Save();
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Process.Start(@"http://eu.battle.net/wow/en/tool/talent-calculator#Vaa!1010200!chiPOo");
        }

        private void frmForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            Settings.Save();
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Process.Start(@"https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=EKFSW4RANKEMG");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Process.Start(
                @"https://www.thebuddyforum.com/honorbuddy-forum/combat-routines/warlock/228429-picas-warlock-pvp-combat-routine-free-edition.html");
        }
    }
}
