﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace GreenDot
{
    class Tools
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private static WoWUnit CTarget { get { return Me.CurrentTarget; } }

        public static bool IsValid(WoWUnit Unit)
        {
            if (Unit == null) return false;

            return Unit.CanSelect && Unit.IsAlive;
        }

        public static bool IsSmallPet(WoWUnit Unit)
        {
            return Unit.MaxHealth <= 20;
        }

        public static async Task<List<WoWUnit>> GetEnemys()
        {
            var Enemys = ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                .Where(u => IsValid(u) && u.Attackable && u.MaxHealth <= 20 && !u.IsTotem && u.IsPlayer)
                .ToList();

            await CommonCoroutines.SleepForLagDuration();

            return Enemys;
        }

        public static async Task<List<WoWUnit>> GetAttackers()
        {
            var Attackers = ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                    .Where(u => u.Attackable && IsValid(u) && !IsSmallPet(u) && u.CurrentTargetGuid == Me.Guid && !u.IsTotem)
                    .ToList();

            await CommonCoroutines.SleepForLagDuration();

            return Attackers;
        }

        public static async Task<List<WoWUnit>> GetEnemyHealers()
        {
            var Healers = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(u => u.Attackable && IsValid(u) && u.IsCastingHealingSpell).ToList();

            await CommonCoroutines.SleepForLagDuration();

            return Healers;
        }

        public static async Task<int> GetEnemysInRange(int MaxRange)
        {
            var Enemys = ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                    .Where(u => u.Attackable && IsValid(u) && !IsSmallPet(u) && u.Distance <= MaxRange && !u.IsTotem && !u.IsPet && !IsSmallPet(u))
                    .ToList().Count();

            await CommonCoroutines.SleepForLagDuration();

            return Enemys;
        }

        public static async Task<bool> GetEnemysInRangeFromTarget(int MaxRange, WoWUnit Target, int EnemyCounts)
        {
            var Enemys = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Count(u => u.Distance <= MaxRange && u.Attackable && IsValid(u) && !u.IsPet && !u.IsTotem);

            await CommonCoroutines.SleepForLagDuration();

            return Enemys >= EnemyCounts;
        }

        public static async Task<int> GetFriendsInRange(int MaxRange)
        {
            var Friends =
                ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                    .Count(u => !u.Attackable && u.IsPlayer && IsValid(u) && !IsSmallPet(u) && u.Distance <= MaxRange);

            await CommonCoroutines.SleepForLagDuration();

            return Friends;
        }

        public static async Task<List<WoWUnit>> GetDemons()
        {
            var Demons =
                ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                    .Where(u => u.Attackable && IsValid(u) && !IsSmallPet(u) && u.IsDemon)
                    .ToList();

            await CommonCoroutines.SleepForLagDuration();

            return Demons;
        }

        public static async Task<List<WoWUnit>> GetPets()
        {
            var Demons =
                ObjectManager.GetObjectsOfTypeFast<WoWUnit>()
                    .Where(u => u.Attackable && IsValid(u) && !IsSmallPet(u) && u.IsPet && !u.IsDemon)
                    .ToList();

            await CommonCoroutines.SleepForLagDuration();

            return Demons;
        }

        public static bool CanSpellLock(WoWUnit Target)
        {
            if (Target == null) return false;

            return Target.IsCasting && Target.CanInterruptCurrentSpellCast;
        }

        public static async Task<bool> Cast(int Spell, bool Condition, WoWUnit Target)
        {
            if (!Condition) return false;
            if (Target == null) return false;
            if (Target.Distance > 40) return false;
            if (!SpellManager.HasSpell(Spell)) return false;
            if (!SpellManager.CanCast(Spell)) return false;
            if (Me.Silenced) return false;
            if (!Target.InLineOfSpellSight) return false;
            if(!Me.IsSafelyFacing(Target)) Target.Face();

            Tools.MoveTo(Target);

            if (!SpellManager.Cast(Spell, Target)) return false;

            Logging.Write(Colors.Gold, string.Format("[CC] Cast Spell:{0} on {1}", WoWSpell.FromId(Spell).Name, Target.SafeName));

            await CommonCoroutines.SleepForLagDuration();

            return true;
        }

        public static async Task CastGroundSpell(int Spell, bool Condition, WoWUnit Target)
        {
            if (!Condition) return;
            if (!IsValid(Target)) return;
            if (Target.Distance > 40) return;
            if (!SpellManager.HasSpell(Spell)) return;
            if (!SpellManager.CanCast(Spell)) return;

            Tools.MoveTo(Target);

            if (!SpellManager.Cast(Spell)) return;

            if (!await Coroutine.Wait(1000, () => Me.CurrentPendingCursorSpell != null))
            {
                Logging.Write(Colors.Gold, string.Format("[CC] CastOnGroundSpell: Cursor don't changing"));
                return;
            }

            SpellManager.ClickRemoteLocation(Target.Location);

            await CommonCoroutines.SleepForLagDuration();
        }

        public static bool LostOfControl(WoWUnit Unit)
        {
            if (Unit == null) return false;

            var result = Unit.Stunned || Unit.Fleeing;

            if (result) Logging.Write(Colors.Gold, string.Format("[CC] Lost of Control: {0}", Unit.SafeName));

            return result;
        }

        private static bool CanUseEquippedItem(WoWItem item)
        {
            string itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);

            if (string.IsNullOrEmpty(itemSpell)) return false;

            return item.Usable && item.Cooldown <= 0;
        }

        public static async Task UseTrinket(int Number, bool Condition)
        {
            if (!Condition) return;

            WoWItem Trinket = null;

            switch (Number)
            {
                case 1:
                    Trinket = Me.Inventory.Equipped.Trinket1;
                    break;

                case 2:
                    Trinket = Me.Inventory.Equipped.Trinket2;
                    break;
            }

            if (Trinket == null) return;

            if (!CanUseEquippedItem(Trinket)) return;

            Trinket.Use();

            Logging.Write(Colors.Gold, string.Format("[CC] Use Trinket {0}", Number));

            await CommonCoroutines.SleepForLagDuration();
        }

        public static bool Dotted(WoWUnit Target)
        {
            if (Target == null) return false;

            return Target.HasAura(Spellbook.aura_Verderbnis) && Target.HasAura(Spellbook.spell_Agonie) && Target.HasAura(Spellbook.spell_InstabilesGebrechen);
        }

        public static async Task UseItem(int Item, bool Condition)
        {
            if (!Condition) return;

            var item = Me.BagItems.FirstOrDefault(i => i.Entry == Item);

            if (item == null) return;

            if (!item.Usable) return;

            if (!item.Use()) return;

            Logging.Write(Colors.Gold, string.Format("[CC] Use Item: {0}", item.SafeName));

            await CommonCoroutines.SleepForLagDuration();
        }

        public static bool HasAura(WoWUnit Unit, int Aura)
        {
            if (Unit == null) return false;

            return Unit.HasAura(Aura);
        }

        public static bool HasItem(int Item)
        {
            var result = Me.BagItems.FirstOrDefault(i => i.Entry == Item);

            if (result == null) return false;

            return true;
        }

        public static void MoveTo(WoWUnit Target)
        {
            if (Target == null) return;

            if (Target.Distance > 35) Navigator.MoveTo(Target.Location);
        }
    }
}
